from shiftregister.app.models import *


class TeamMember(models.Model):
    name = models.CharField(max_length=100)
    fallback_shifts = models.ManyToManyField(Shift, through='FallbackAssignment')

    def assign_random_shifts(self):
        shifts = Shift.objects.order_by('?')[:5]
        for shift in shifts:
            self.fallback_shifts.add(shift)

    def __str__(self):
        return f"{self.name}"


class FallbackAssignment(models.Model):
    shift = models.ForeignKey(Shift, on_delete=models.CASCADE)
    team_member = models.ForeignKey(TeamMember, on_delete=models.CASCADE)

    def __str__(self):
        return f"{self.shift} {self.team_member.name}"
